import java.net.*;
import java.io.*;
import java.security.*;
import java.math.*;


public class URLDigest {

  public static void main(String[] args) {

    for (int i = 0; i < args.length; i++) {
      try {
        URL u = new URL(args[i]);
        printDigest(u.openStream());
      }
      catch (MalformedURLException e) {
        System.err.println("Il parametro"+ args[i] + " non rappresenta un  URL corretto");
      }
      catch (Exception e) {
        System.err.println(e);
      }

    }

  }

  public static void stampaDigest(InputStream in)  throws IOException, NoSuchAlgorithmException {
    
     MessageDigest sha = MessageDigest.getInstance("SHA");
     byte[] data = new byte[128];
     for (;;) {
       int bytes = in.read(data);
       if (bytes < 0) break;
       sha.update(data, 0, bytes);
     }

     byte[] result = sha.digest();
     for (int i = 0; i < result.length; i++) {
       System.out.print(result[i] + " ");
     }
     System.out.println();
     System.out.println(new BigInteger(result));

  }

}
